#include "util.h"

#include <stdlib.h>

klist_app *klist_app_init(char *db) {
  klist_app *app = malloc(sizeof(klist_app));
  app->cmd = 0;
  app->cmd_ctx = 0;
  app->error = 0;
  app->log_ctx = malloc(sizeof(klist_logging_ctx));
  app->log_ctx->log_level = KLIST_LOG_DEBUG;
  app->log_ctx->log_target = stderr;
  app->handle = klist_init(db);
  app->handle->log_ctx->log_level = app->log_ctx->log_level;
  app->handle->log_ctx->log_target = app->log_ctx->log_target;
  return app;
}
void klist_app_deinit(klist_app *ctx) {
  free(ctx->log_ctx);
  if (ctx->handle)
    klist_deinit(ctx->handle);
  free(ctx);
}

klist_user_context *klist_user_context_init() {
  klist_user_context *ctx = malloc(sizeof(klist_user_context));
  ctx->cmd = -1;
  return ctx;
}
void klist_user_context_deinit(klist_user_context *ctx) {
  free(ctx);
  ctx = NULL;
}

klist_list_context *klist_list_context_init() {
  klist_list_context *ctx = malloc(sizeof(klist_list_context));
  ctx->cmd = -1;
  ctx->name = NULL;
  ctx->desc = NULL;
  ctx->stages = NULL;
  ctx->stages_len = 0;
  ctx->preset = NULL;
  return ctx;
}
void klist_list_context_deinit(klist_list_context *ctx) {
  if (ctx->name)
    free(ctx->name);
  if (ctx->desc)
    free(ctx->desc);
  if (ctx->preset)
    free(ctx->preset);
  if (ctx->stages) {
    int i = 0;
    for (; i < ctx->stages_len; i++)
      free(ctx->stages[i]);
    free(ctx->stages);
  }
  free(ctx);
  ctx = NULL;
}

klist_task_context *klist_task_context_init() {
  klist_task_context *ctx = malloc(sizeof(klist_task_context));
  ctx->cmd = -1;
  ctx->name = NULL;
  ctx->desc = NULL;
  ctx->list = NULL;
  ctx->stage = NULL;
  return ctx;
}
void klist_task_context_deinit(klist_task_context *ctx) {
  if (ctx->name)
    free(ctx->name);
  if (ctx->list)
    free(ctx->list);
  if (ctx->stage)
    free(ctx->stage);
  free(ctx);
  ctx = NULL;
}
